package userdata

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"io"
	"net/http"

	"github.com/gin-gonic/gin"
	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"

	"github.com/SecurityBrewery/catalyst/generated/models"
	"github.com/SecurityBrewery/catalyst/generated/restapi/api"
)

// UpdateUserDataEndpoint executes the core logic of the related
// route endpoint.
func UpdateUserDataEndpoint(handler func(ctx context.Context, params *UpdateUserDataParams) *api.Response) gin.HandlerFunc {
	return func(ctx *gin.Context) {

		// generate params from request
		params := NewUpdateUserDataParams()
		err := params.ReadRequest(ctx)
		if err != nil {
			errObj := err.(*errors.CompositeError)
			ctx.Writer.Header().Set("Content-Type", "application/problem+json")
			ctx.JSON(int(errObj.Code()), gin.H{"error": errObj.Error()})
			return
		}

		resp := handler(ctx, params)

		switch resp.Code {
		case http.StatusNoContent:
			ctx.AbortWithStatus(resp.Code)
		default:
			ctx.JSON(resp.Code, resp.Body)
		}
	}
}

// NewUpdateUserDataParams creates a new UpdateUserDataParams object
// with the default values initialized.
func NewUpdateUserDataParams() *UpdateUserDataParams {
	var ()
	return &UpdateUserDataParams{}
}

// UpdateUserDataParams contains all the bound params for the update user data operation
// typically these are obtained from a http.Request
//
// swagger:parameters updateUserData
type UpdateUserDataParams struct {

	/*User Data ID
	  Required: true
	  In: path
	*/
	ID string
	/*User data object that needs to be added
	  Required: true
	  In: body
	*/
	Userdata *models.UserData
}

// ReadRequest both binds and validates a request, it assumes that complex things implement a Validatable(strfmt.Registry) error interface
// for simple values it will use straight method calls
func (o *UpdateUserDataParams) ReadRequest(ctx *gin.Context) error {
	var res []error

	rID := []string{ctx.Param("id")}
	if err := o.bindID(rID, true); err != nil {
		res = append(res, err)
	}

	if runtime.HasBody(ctx.Request) {
		var body models.UserData
		if err := ctx.BindJSON(&body); err != nil {
			if err == io.EOF {
				res = append(res, errors.Required("userdata", "body", ""))
			} else {
				res = append(res, errors.NewParseError("userdata", "body", "", err))
			}

		} else {
			o.Userdata = &body
		}
	} else {
		res = append(res, errors.Required("userdata", "body", ""))
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *UpdateUserDataParams) bindID(rawData []string, hasKey bool) error {
	var raw string
	if len(rawData) > 0 {
		raw = rawData[len(rawData)-1]
	}

	o.ID = raw

	return nil
}
